#define LED_PIN LED_BUILTIN

#define LED_OFF 0
#define LED_ON 1
#define LED_BLINK 2

#include <###.h>
### tickerLed;

bool onVal = LOW;
bool offVal = HIGH;

int mode; // 0:off, 1:on, 2:blink
int onMil = 3000;
int offMil = 500;

volatile bool blinkOn;
volatile unsigned long nextMil;

void ### ledISR() {
  if (mode == LED_BLINK) {
    if(blinkOn && millis() > nextMil) {
      digitalWrite(LED_PIN,offVal);
      blinkOn = false;
      nextMil = millis() + offMil;
    }
    else if(!blinkOn && millis() > nextMil) {
      digitalWrite(LED_PIN,onVal);
      blinkOn = true;
      nextMil = millis() + onMil;
    }
  }
}

void setup() {
  Serial.begin(115200);
  Serial.println();
  
  Serial.println("Input m 0 for led off");
  Serial.println("Input m 1 for led on");
  Serial.println("Input m 2 for led blink");

  tickerLed.###(10,ledISR); // 10 밀리 초

  pinMode(LED_PIN,OUTPUT);
}

void loop() {
  while(Serial.available()) {
    char c = Serial.read();
    if (c == 'm') { 
      int val = Serial.parseInt();
      switch (val) {
        case 0 : mode = LED_OFF;
                 digitalWrite(LED_PIN,offVal);
                 Serial.println("mode=LED_OFF");
                 break;
        case 1 : mode = LED_ON;
                 digitalWrite(LED_PIN,onVal);
                 Serial.println("mode=LED_ON");
                 break;
        case 2 : mode = LED_BLINK;
                 digitalWrite(LED_PIN,onVal);                 
                 blinkOn = true;
                 nextMil = millis() + onMil;
                 Serial.println("mode=LED_BLINK");
                 break;
        default: Serial.println("mode ERROR!!");
                 continue;
      }
    }
  }
}