#define LED_OFF 0
#define LED_ON 1
#define LED_BLINK 2

#define ON_MIL 3000
#define OFF_MIL 500

// class 이름 첫글자는 대문자가 좋음
class Led {

  // 외부에 알려짐
  public:
    // constructor
    // class 이름 사용
    // void가 없음
    Led(int pin, bool onVal);

    void setOnMil(int val);
    void setOffMil(int val);
    void off();
    void on();
    void blink();
    void run();
    ### getModeStr();

  // 내부에서만 사용
  private:
    int pin;  
    bool onVal;
    bool offVal;

    int mode; // 0:LED_OFF, 1:LED_ON, 2:LED_BLINK
    int onMil;
    int offMil;

    bool blinkOn;
    unsigned long nextMil;
}; // {}의 끝에 ;이 있음

// constructor,void가 없음
Led::Led(int INpin, bool INonVal) {
  pin = INpin;
  onVal = INonVal;
  offVal = !onVal;

  mode = LED_OFF;
  onMil = ON_MIL;
  offMil = OFF_MIL;
  pinMode(pin,OUTPUT);
  digitalWrite(pin,offVal); // off
}

void Led::setOnMil(int INval) {
  onMil = INval;
}

void Led::setOffMil(int INval) {
  offMil = INval;
}

void Led::off() {
  mode = LED_OFF;
  digitalWrite(pin,offVal);
}

void Led::on() {
  mode = LED_ON;
  digitalWrite(pin,onVal);
}

void Led::blink() {
  mode = LED_BLINK;
  digitalWrite(pin,onVal);                
  blinkOn = true;
  nextMil = millis() + onMil;
}

void Led::run() {
  if (mode == LED_BLINK) {
    if(blinkOn && millis() > nextMil) {
      digitalWrite(pin,offVal);
      blinkOn = false;
      nextMil = millis() + offMil;
    }
    else if(!blinkOn && millis() > nextMil) {
      digitalWrite(pin,onVal);
      blinkOn = true;
      nextMil = millis() + onMil; 
    }
  }
}

### Led::getModeStr() {
  String modeStr;
  switch(###) {
    case 0 : modeStr = "OFF";
             ###;
    case 1 : modeStr = "ON";
             ###;
    case 2 : modeStr = "BLINK";
             ###;
    defualt : modeStr = "";
             ###; 
  }
  return ###;
}