#define LED_OFF 0
#define LED_ON 1
#define LED_BLINK 2

#define ON_MIL 3000
#define OFF_MIL 500

// class 이름 첫글자는 대문자가 좋음
### ### {

  // 외부에 알려짐
  ###:
    // constructor
    // class 이름 사용
    // void가 없음
    ###(int pin, bool onVal);

    void setOnMil(int val);
    void setOffMil(int val);
    void off();
    void on();
    void blink();
    void run();

  // 내부에서만 사용
  ###:
    int pin;  
    bool onVal;
    bool offVal;

    int mode; // 0:LED_OFF, 1:LED_ON, 2:LED_BLINK
    int onMil;
    int offMil;

    bool blinkOn;
    unsigned long nextMil;
}### // {}의 끝에 ;이 있음

// constructor,void가 없음
###Led(int INpin, bool INonVal) {
  pin = INpin;
  onVal = INonVal;
  offVal = !onVal;

  mode = LED_OFF;
  onMil = ON_MIL;
  offMil = OFF_MIL;
  pinMode(pin,OUTPUT);
  digitalWrite(pin,offVal); // off
}

void ###setOnMil(int INval) {
  onMil = INval;
}

void ###setOffMil(int INval) {
  offMil = INval;
}

void ###off() {
  mode = LED_OFF;
  digitalWrite(pin,offVal);
}

void ###on() {
  mode = LED_ON;
  digitalWrite(pin,onVal);
}

void ###blink() {
  mode = LED_BLINK;
  digitalWrite(pin,onVal);                
  blinkOn = true;
  nextMil = millis() + onMil;
}

void ###run() {
  if (mode == LED_BLINK) {
    if(blinkOn && millis() > nextMil) {
      digitalWrite(pin,offVal);
      blinkOn = false;
      nextMil = millis() + offMil;
    }
    else if(!blinkOn && millis() > nextMil) {
      digitalWrite(pin,onVal);
      blinkOn = true;
      nextMil = millis() + onMil; 
    }
  }
}