#define LED_PIN LED_BUILTIN

#define LED_OFF 0
#define LED_ON 1
#define LED_BLINK 2

#define ON_MIL 3000
#define OFF_MIL 500

bool onVal;
bool offVal;

int mode; // 0:off, 1:on, 2:blink
int onMil;
int offMil;

bool blinkOn;
unsigned long nextMil;

void ledInit(int pin, bool INonVal) {
  onVal = INonVal;
  offVal = !onVal;

  mode = LED_OFF;
  onMil = ON_###;
  offMil = OFF_###;
  pinMode(pin,OUTPUT);
  digitalWrite(pin,###Val); // off
}

void ledSetOnMil(int INval) {
  onMil = INval;
}

void ledSetOffMil(int INval) {
  offMil = INval;
}

void ledOff() {
   digitalWrite(LED_PIN,offVal);
}

void ledOn() {
   digitalWrite(LED_PIN,onVal);
}

void ledBlink() {
  digitalWrite(LED_PIN,onVal);                
  blinkOn = true;
  nextMil = millis() + onMil;
}

void ledRun() {
  if (mode == LED_BLINK) {
    if(### && millis() > nextMil) {
      digitalWrite(LED_PIN,offVal);
      blinkOn = false;
      nextMil = millis() + ###Mil;
    }
    else if(### && millis() > nextMil) {
      digitalWrite(LED_PIN,onVal);
      blinkOn = true;
      nextMil = millis() + ###Mil;
    }
  }
}

void setup() {
  Serial.begin(115200);
  Serial.println();
 
  Serial.println("Input m 0 for led off");
  Serial.println("Input m 1 for led on");
  Serial.println("Input m 2 for led blink");
  Serial.println("Input n nnn for onMil");
  Serial.println("Input f nnn for offMil");

  ledInit(LED_PIN,LOW); // PIN, onVal
}

void loop() {

  while(Serial.available()) {
    char c = Serial.read();
    if (c == 'm') {
      int val = Serial.parseInt();
      switch (val) {
        case 0 : mode = LED_OFF;
                 ledOff();              
                 Serial.println("mode=LED_OFF");
                 break;
        case 1 : mode = LED_ON;
                 ledOn();
                 Serial.println("mode=LED_ON");
                 break;
        case 2 : mode = LED_BLINK;
                 ledBlink();
                 Serial.println("mode=LED_BLINK");
                 break;
        default: Serial.println("mode ERROR!!");
      }
    }
    else if (c == 'n') {
      int val = Serial.parse###();
      ledSetOnMil(val);
      Serial.printf("ledSetOnMil=%d\n",val);
    }
    else if (c == 'f') {
      int val = Serial.parse###();
      ledSetOffMil(val);
      Serial.printf("ledSetOffMil=%d\n",val);
    }
  }

  led###(); // LED_BLINK일 때 ON,OFF
}