#include <###.h>
#include "###.h"

// constructor,void가 없음
Led::Led(int INpin, bool INonVal) {
  pin = INpin;
  onVal = INonVal;
  offVal = !onVal;

  mode = LED_OFF;
  onMil = ON_MIL;
  offMil = OFF_MIL;
  pinMode(pin,OUTPUT);
  digitalWrite(pin,offVal); // off
}

void Led::setOnMil(int INval) {
  onMil = INval;
}

void Led::setOffMil(int INval) {
  offMil = INval;
}

void Led::off() {
  mode = LED_OFF;
  digitalWrite(pin,offVal);
}

void Led::on() {
  mode = LED_ON;
  digitalWrite(pin,onVal);
}

void Led::blink() {
  mode = LED_BLINK;
  digitalWrite(pin,onVal);                
  blinkOn = true;
  nextMil = millis() + onMil;
}

void Led::run() {
  if (mode == LED_BLINK) {
    if(blinkOn && millis() > nextMil) {
      digitalWrite(pin,offVal);
      blinkOn = false;
      nextMil = millis() + offMil;
    }
    else if(!blinkOn && millis() > nextMil) {
      digitalWrite(pin,onVal);
      blinkOn = true;
      nextMil = millis() + onMil; 
    }
  }
}