#define ALARM_ON_SEC 5.0

#include <AimSerial.h>
AimSerial mySerial;

#include <AimOutput.h>
AimOutput led(LED_BUILTIN,LOW);

#include <Aim###.h>
Aim### sandLed(ALARM_ON_SEC);

#include <AimTimer.h>
AimTimer timerRemain(1);

void setup() {
  Serial.begin(115200);
  Serial.println();
  Serial.println("Input 'on|off|dur'");
  Serial.println("Input 'set 5' for 5 durationSec ");

  mySerial.begin(mySerialCallback);
}

void loop() {
  led.run();
  mySerial.run();
 
  if (sandLed.to###()) {
    led.set(700,300);
    Serial.printf("sandLed : ON\n");
  }
  else if (sandLed.to###()) {
    led.off();
    Serial.printf("sandLed : OFF\n");
  }

  if (timerRemain.isOn()) {
    if (sandLed.is###()) {
      Serial.printf("remaining ... %.0f\n",
                       sandLed.###Remain());
    }  
  }
}

void mySerialCallback(const String& key,const String& val){
  if (key == "on") {
    sandLed.###();
  }
  else if (key == "off") {
    sandLed.###();
  }  
  else if (key == "set") {
    sandLed.###Duration(val.toFloat());
    Serial.printf("durationSec=%.0f\n",sandLed.###Duration());
  }
  else if (key == "dur") {
    Serial.printf("durationSec=%.01f\n",sandLed.###Duration());
  }
}