// PIN  
#define LED_PIN  LED_BUILTIN
#define LED_ON   LOW        // Sink mode

// topic path : PREFIX+'/'+TOPIC 
//#define PREFIX      "{{user}}/feeds/" 
#define PREFIX      ""  

// topic 
#define TOPIC_LED   "led"   // 1:ON, 0:OFF
#define TOPIC_LED_R "led-r" // LED 상태 응답
#define TOPIC_MSG   "msg"   // 진행 상태 보고
#define TOPIC_TEXT  "text"   // 진행 상태 보고

// WiFi,MQTT 설정정보
#include <myConfig.h> 
#include <AimMqtt.h>
AimMqtt mqtt;

#include <AimSerial.h>
AimSerial mySerial;

void setup() {

  pinMode(LED_PIN, OUTPUT);   
  digitalWrite(LED_PIN,!LED_ON); // off
    
  Serial.begin(115200);
  Serial.println();  

  mqtt.configHelp();  // Config 정보 안내 출력 
  mqtt.begin(###,###);  

  mySerial.begin(mySerialCallback);
}

void loop() {
  mqtt.###();
  mySerial.run();

  // 10초마다 카운트를 publish 
  static unsigned long nextMil = millis() + 10000;  
  if (millis() > nextMil) {
    nextMil = millis() + 10000;

    static unsigned long value = 0;
    ++value;

    mqtt.###(TOPIC_MSG,value); // publish
  }
}

//-----
// MQTT서버에 처음/다시 접속할 때마다 수행
//-----
void myMqttSub() {  
  int QoS = 1;
  mqtt.###(TOPIC_LED,QoS);
}

//-----
// TOPIC이 수신될 때마다 수행
//-----
void myMqttCallback(const String& topic, const String& payload) {   
  // 수신된 topic,payload 처리   
  if (topic == TOPIC_LED) {
    int ledVal;    
    if (payload == "1") {
      ledVal = LED_ON;
    }
    else {
      ledVal = !LED_ON;
    }    
    digitalWrite(LED_PIN,ledVal );
    mqtt.###(TOPIC_LED_R,payload,true);
    mqtt.###(TOPIC_TEXT,payload == "1" ### "ON" ### "OFF",true);
  } 
}

//-----
// 시리얼 모니터에서 key,val이 입력될 때마다 수행
//-----
void mySerialCallback(const String& key,const String& val) {  
  Serial.printf("-----\nINP> [%s],[%s]\n",key.c_str(),val.c_str());

  // Config정보 수정하여 보관 
  if (mqtt.configSerial(key,val)) {
    return;
  }

  // 입력된 key,val 처리 
  if (key == TOPIC_LED) {
    mqtt.pub(TOPIC_LED,val,true);
  }
}