// topic
#define TOPIC_LED   "led"   // 1:ON, 0:OFF
#define TOPIC_LED_R "led-r" // LED 상태 응답
#define TOPIC_MSG   "msg"   // 진행 상태 보고
#define PREFIX      ""      // 없으면 "" 또는 생략
// WiFi,MQTT(설정정보,라이브러리)
#include <myConfig.h>
#include <Aim###.h>

// 라이브러리
#include <AimOutput.h>
#include <AimSerial.h>
#include <AimTimer.h>

// 오브젝트 생성
Aim### mqtt;
AimOutput led(LED_BUILTIN,LOW);
AimSerial mySerial;
AimTimer  timerMsg(10);

void setup() {
  led.off();

  Serial.begin(115200);
  Serial.println();

  mqtt.begin(###,###);  
  mySerial.begin(mySerialCallback);
}

void loop() {
  mqtt.###();
  mySerial.run();

  if (timerMsg.isOn()) {
    static unsigned long value = 0;
    mqtt.###(TOPIC_MSG,++value);
  }
}

//-----
// MQTT서버에 처음/다시 접속할 때마다 수행
//-----
void myMqttSub() {  
  int QoS = 1;
  mqtt.###(TOPIC_LED,QoS);
}

//-----
// TOPIC이 수신될 때마다 수행
//-----
void myMqttCallback(const String& topic, const String& payload){
  // 수신된 topic,payload 처리  
  if (topic == TOPIC_LED) {
    led.set(payload);
    mqtt.###(TOPIC_LED_R,led.status(),true);
  }
}

//-----
// 시리얼 모니터에서 key,val이 입력될 때마다 수행
//-----
void mySerialCallback(const String& key,const String& val) {
  if (key == TOPIC_LED) {
    mqtt.###(TOPIC_LED,val,true);
  }
}