// pin
#define LED_PIN   LED_BUILTIN
#define RELAY_PIN D1        
#define BTN_PIN   D3        

// TOPIC
#define PREFIX         "room/"
#define TOPIC_RELAY    "relay"
#define TOPIC_RELAY_R  "relay-r"

#include <AimInput.h>
#include <AimOutput.h>
#include <AimSerial.h>

#include <myConfig.h>
#include <AimMqtt.h>

AimInput  btn(BTN_PIN,LOW,INPUT_PULLUP);
AimOutput led(LED_PIN,LOW);
AimOutput relay(RELAY_PIN,HIGH);
AimSerial mySerial;
AimMqtt   mqtt;

void setup() {
  Serial.begin(115200);
  Serial.println();
  mySerial.begin(mySerialCallback);
  mqtt.configHelp();
  mqtt.begin(myMqttSub,myMqttCallback);
}

void loop() {
  mqtt.run();  
  mySerial.run();
  led.run();
  relay.###();
  btn.run();
  if (btn.pressed()) {
    relay.###();
    mqtt.pub(TOPIC_RELAY,relay.###("ON","OFF"));
  }
}

// MQTT접속 직후 수행
void myMqttSub() {
  mqtt.sub(TOPIC_RELAY,1);
}

// subscribe한 topic이 수신되면 수행됨
void myMqttCallback(const String& topic,const String& payload){
  if (topic == TOPIC_RELAY) {
    relay.###(payload);
    led.set(relay.###());
    mqtt.pub(TOPIC_RELAY_R,relay.###("ON","OFF"));
  }
}

// 'relay 1' 또는 'relay 0' 입력
void mySerialCallback(const String& key,const String& val) {
  if (key == TOPIC_RELAY) {
    mqtt.pub(TOPIC_RELAY, val == "1" ? "ON" : "OFF", true);
  }
  mqtt.configSerial(key,val);
}