// pin
#define DHT22_PIN    D4         

// TOPIC 
#define PREFIX       "room/" 
#define TOPIC_TEMP   "temp"
#define TOPIC_HUM    "hum" 

#include <AimTimer.h>
#include <myConfig.h>
#include <AimMqtt.h>

AimTimer timerTemp(10);
AimTimer timerHum(10);
AimTimer timerOled(3);
AimMqtt mqtt;

// Aims
#include <Aims_dht22.h>
#include <Aims_oled_shield.h>

Aims_dht22 dht(DHT22_PIN,DHT22);
Aims_oled  oled;

void setup() {
  Serial.begin(115200);
  Serial.println();
  mqtt.begin(myMqttSub,myMqttCallback);
}
void loop() {
  mqtt.run();

  if (timerTemp.isOn()) {
    mqtt.pub(TOPIC_TEMP,dht.getTemp(),1);
  }
  else if (timerHum.isOn()) {
    mqtt.pub(TOPIC_HUM,dht.getHum(),0);
  } 
  
  if (timerOled.isOn()) {
    displayOled();
  } 
}

void myMqttSub() {
  
}

void myMqttCallback(const String& topic, const String& payload) { 

}

void displayOled() {
  ### int cntMax = 3; // 스크린 수
  ### int cnt = 0;   // 표시할 스크린
  cnt = ++cnt > cntMax ? 1 : cnt;
  switch(cnt) {
    case 1: oled.keyVal("온도",String(dht.temp(),1));
            break;
    case 2: oled.keyVal("습도",String(dht.hum(),0));
            break;
    case 3: ####();
            break;
  }   
}