// pin
#define DHT22_PIN    D4        

// TOPIC
#define PREFIX       "room/"
#define TOPIC_TEMP   "temp"
#define TOPIC_HUM    "hum"

#include <AimTimer.h>
#include "myConfig.h"
//#define SHOW_PASS
//#define USE_CONFIG
#include <AimMqtt.h>

AimTimer timerTemp(10);
AimTimer timerHum(10);
AimTimer timerOled(3);
AimMqtt mqtt;

#include <AimSerial.h>
AimSerial mySerial;

// Aims
#include <Aims_dht22.h>
#include <Aims_oled_shield.h>

Aims_dht22 dht(DHT22_PIN,DHT22);
Aims_oled  oled;

void setup() {
  Serial.begin(115200);
  Serial.println();
  Serial.println("started!!");

  //mqtt.ap("mingky","$happydays777$");
  //mqtt.setSub(myMqttSub);
  //mqtt.setCallback(myMqttCallback);
  mqtt.begin(myMqttSub,myMqttCallback);
  mqtt.configHelp();
  mySerial.begin(mySerialCB);
}
void loop() {
  mqtt.run();
  mySerial.run();
  //mqtt.pub(TOPIC_TEMP,dht.getTemp(),1); 
  //Serial.println("mqtt_pub temp");
  //delay(2000); 

  if (timerTemp.isOn()) {
    mqtt.pub(TOPIC_TEMP,dht.getTemp(),1);
    Serial.println("mqtt_pub temp");
  }
  else if (timerHum.isOn()) {
    mqtt.pub(TOPIC_HUM,dht.getHum(),0);
    Serial.println("mqtt_pub hum");
  }
  
  if (timerOled.isOn()) {
    displayOled();
    Serial.println("displayOled");
  }
  
}

void myMqttSub() {
 
}

void myMqttCallback(const String& topic, const String& payload) {
  String newTopic = topic;
  String newpayload = payload;
}

void displayOled() { 
  
  const int cntMax = 2; // 스크린 수
  static int cnt = 0;   // 표시할 스크린
  cnt = ++cnt > cntMax ? 1 : cnt;
  return;
  switch(cnt) {
    case 1: oled.keyVal("온도",String(dht.temp(),1));
            break;
    case 2: oled.keyVal("습도",String(dht.hum(),0));
            break;
  }  
}

void mySerialCB(String key,String val) {
  Serial.printf("input: key=[%s],val=[%s]\n",key.c_str(),val.c_str());
  mqtt.setConfig(key,val);
}