// pin
//#define DHT22_PIN    D4        

// TOPIC
#define PREFIX       "room/"
#define TOPIC_TEMP   "temp"
#define TOPIC_HUM    "hum"

#include <AimTimer.h>
#include <myConfig.h>
#include <AimMqtt.h>

AimTimer timerTemp(10);
AimTimer timerHum(10);
AimTimer timerOled(3);
AimMqtt mqtt;

// Aims
#include <Aims_###.h>  // #include <Aims_dht22.h>
#include <Aims_###_shield.h>

Aims_### dht; // Aims_dht22 dht(DHT22_PIN,DHT22);
Aims_###  oled;

void setup() {
  Serial.begin(115200);
  Serial.println();
  mqtt.begin(myMqttSub,myMqttCallback);
}
void loop() {
  mqtt.run();

  if (timerTemp.isOn()) {
    mqtt.pub(TOPIC_TEMP,dht.###Temp(),1);
  }
  else if (timerHum.isOn()) {
    mqtt.pub(TOPIC_HUM,dht.###Hum(),0);
  }
 
  if (timerOled.isOn()) {
    displayOled();
  }
}

void myMqttSub() {
 
}

void myMqttCallback(const String& topic, const String& payload) {

}

void displayOled() {
  const int cntMax = 2; // 스크린 수
  static int cnt = 0;   // 표시할 스크린
  cnt = ++cnt > cntMax ? 1 : cnt;
  switch(cnt) {
    case 1: oled.keyVal("온도",String(dht.###(),1));
            break;
    case 2: oled.keyVal("습도",String(dht.###(),0));
            break;
  }  
}