// pin
#define LED_PIN    LED_BUILTIN // D0
#define MOTION_PIN D3
#define MOTION_ON_SEC 10

// topic
#define PREFIX               "alarm"
#define TOPIC_MOTION         "motion"
#define TOPIC_REPORT_ALARM   "report-alarm"
#define TOPIC_REPORT_ALARM_R "report-alarm-r"

// Aim
#include <AimOutput.h>
#include <Aim###.h>
#include <AimSerial.h>

#include <myConfig.h>
#include <AimMqtt.h>

AimOutput led(LED_PIN,LOW);
Aim###  motion(MOTION_PIN,HIGH,INPUT,MOTION_ON_SEC);
AimMqtt   mqtt;
AimSerial mySerial;

void setup() {
  Serial.begin(115200);
  Serial.println();

  mqtt.begin(myMqttSub,myMqttCallback);
  mySerial.begin(mySerialCallback);
}

void loop() {
  mqtt.run();
  led.run();
  mySerial.run();

  if (motion.to###()) {
    mqtt.pub(TOPIC_MOTION,"ON");
    led.set(700,300);
  }
  else if(motion.to###()) {
    mqtt.pub(TOPIC_MOTION,"OFF");
    led.off();
  }
}

void myMqttSub() {
  mqtt.sub(TOPIC_REPORT_ALARM,1);
}

void myMqttCallback(const String& topic,const String& payload) {
  if (topic == TOPIC_REPORT_ALARM) {
    bool reportAlarm = mqtt.toBool(payload);
    mqtt.pub(TOPIC_REPORT_ALARM_R,reportAlarm);  

    if (reportAlarm) {
      motion.###();
    }
    else {
      motion.###();
    }    
  }
}

void mySerialCallback(const String& key,const String& val) {
  if (key == "alarm") {
    mqtt.pub(TOPIC_REPORT_ALARM,mqtt.toBool(val),true);
  }
}